// D import file generated from 'derelict/freeimage/freeimage.d'
module derelict.freeimage.freeimage;
public 
{
	import derelict.freeimage.functions;
	import derelict.freeimage.types;
}
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "FreeImage.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libfreeimage.dylib,libfreeimage.dylib.3";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libfreeimage.so,libfreeimage.so.3";
			}
			else
			{
				static assert(0, "Need to implement FreeImage libNames for this operating system.");
			}
		}
	}
}
class DerelictFILoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictFILoader DerelictFI;

shared static this();
